package bookExamples.ch26Graphics.draw2d;

import java.awt.*;

public class Pentagon extends Shape {
    int h = 1;
    int w = 1;
    int xc = 0;
    int yc = 0;

    public Shape getInstance(int x1, int y1, int x2, int y2) {
        return new Pentagon(x1, y1, x2, y2);
    }

    public int getX() {
        return x1;
    }

    public int getY() {
        return y1;
    }

    public int getW() {
        return w;
    }

    public int getH() {
        return h;
    }


    public Pentagon(int _x1, int _y1, int _x2, int _y2) {
        super(_x1, _y1, _x2, _y2);
        setX1(_x1);
        setY1(_y1);
        w = Math.abs(_x2 - x1);
        h = Math.abs(_y2 - y1);
        if (_x1 > _x2) setX1(_x2);
        if (_y1 > _y2) setY1(_y2);
        xc = x1 + w / 2;
        yc = y1 + h / 2;
    }

    public void paint(Graphics g) {
        double r = w / (2 * Math.sin(Math.toRadians(72))); //Length of radius
        double n = Math.sin(Math.toRadians(37)) /
                Math.sin(Math.toRadians(72));              //A constant
        double a = w * n;                                  //Length of side

        int[] xPoints = {x1 + w / 2,
                         x1 + w,
                         (int) (x1 + w / 2 + a / 2),
                         (int) (x1 + w / 2 - a / 2),
                         x1};
        int[] yPoints = {(int) (y1 + r *
                (Math.cos(Math.toRadians(36)) + 1)),
                         (int) (y1 + r * (Math.cos(Math.toRadians(36)) +
                Math.cos(Math.toRadians(72)))),
                         y1, y1,
                         (int) (y1 + r * (Math.cos(Math.toRadians(36)) +
                Math.cos(Math.toRadians(72))))};

        g.drawPolygon(xPoints, yPoints, 5);
        g.fillOval(xc, yc, 2, 2);
        g.drawString("(" + xc + "," + yc + ")", xc + 3, yc + 3);
    }
}
